'37_in_1, KY-039, Detect the Heartbeat Module

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Const Pulse_th = 2                                          'Pulse treshold in mV = 5*Pulse_th

Dim I1 As Byte , I2 As Byte
Dim Pulse_levels(32) As Word
Dim Pulse_level As Word
Dim Pulse_count_on As Byte , Pulse_count_off As Byte
Dim Pulse_time As Long , Pulse As Word

Config Clockdiv = 1
Config Base = 0

$include "Arduino_pins.sub"                                 'include Arduino pin definitions

Config Arduino_port#12 = Output
Arduino_port#12 = 0

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Config Timer1 = Timer , Prescale = 1024

Wait 1
Print "37_in_1 demo program 8"
Print "A0 = analog input"
Print "#12 = digital output"
Print

I1 = 0
Pulse_count_on = 0
Pulse_count_off = 0

Do
  Incr I1
  I1 = I1 And &B00011111
  Pulse_levels(i1) = Getadc(0)
  Gosub Calc_level
  If Pulse_levels(i1) > Pulse_level Then
    If Pulse_count_on < 255 Then
      Incr Pulse_count_on
    End If
    If Pulse_count_on = 3 Then
      Stop Timer1
      Pulse_time = Timer1
      Timer1 = 0
      Set Gtccr.psrsync
      Start Timer1
      Gosub Calc_pulse
    End If
    Pulse_count_off = 0
    Arduino_port#12 = 1
  Else
    If Pulse_count_off < 255 Then
      Incr Pulse_count_off
    End If
    Pulse_count_on = 0
    Arduino_port#12 = 0
  End If
  If Pulse_count_on = 254 Or Pulse_count_off = 254 Then
    Print "pulse error"
  End If
  Waitms 10
Loop

End

Calc_level:
  Pulse_level = 16                                          'avg + pulse_th*5 mV
  For I2 = 0 To 31
    Pulse_level = Pulse_level + Pulse_levels(i2)
  Next
  Pulse_level = Pulse_level / 32
  Pulse_level = Pulse_level + Pulse_th
Return

Calc_pulse:
  Pulse_time = 937500 / Pulse_time
  Pulse = Pulse_time
  Print "pulse = " ; Pulse
Return